#!/bin/bash
#\
exec tclsh "$0" "$@"

set CDIR [pwd]
cd data/docs
proc readEvents {fd} {        
    puts $fd "<dd><p>"
    set sw 0
    set cmd ""
    set fd2 [open ../../events.cpp r]
    while {![eof $fd2]} {
        gets $fd2 data
        if {$sw} {
            if {$cmd == ""} {
                set cmd $data
                set args [llength [lrange $cmd 1 end]]
                puts $fd ""
                if {$args == 0} {
                    puts $fd "<b>[lindex $cmd 0]</b><br>"
                } else {
                    puts -nonewline $fd "<b>[lindex $cmd 0]</b>"
                    foreach arg [lrange $cmd 1 end] {
                        puts -nonewline $fd " &nbsp\;&nbsp\;<i>[string map {[ [<b> ] </b>]} $arg]</i>"
                    }
                    puts $fd "<br>"
                }
            } else {
                if {$data != "*/"} {
                    puts $fd "$data<br>"
                } else {
                    set cmd ""
                    set sw 0
                }
            }
        } else {
            if {$data == "/* Tcl Event"} {
                set sw 1
                puts $fd "<br>"
            }
        }
    }
    close $fd2
}


# Other commands
set fd2 [open ../../commands.cpp r]
set fd ""
set sw 0
set DESCR 0
set syntax_words_b ""
set syntax_words_i ""

while {![eof $fd2]} {
    gets $fd2 data
    if {$sw} {
        switch -- [lindex [split $data] 0] {
            SYNTAX: {
                if {$DESCR} {
                    set syntax_words_b ""
                    set syntax_words_i ""
                    set DESCR 0
                }
                puts -nonewline $fd "<dt><b>[lindex $data 1]</b>"
                lappend syntax_words_b [lindex $data 1]
                if {[llength $data] > 2} {
                    set idx 2
                    while {[lindex $data $idx] != ""} {
                        puts -nonewline $fd " "
                        switch -glob -- [lindex $data $idx] {
                            \\?-*\\? {
                                puts -nonewline $fd "?<b>[string range [lindex $data $idx] 1 end-1]</b>?"
                                lappend syntax_words_b [string range [lindex $data $idx] 1 end-1]
                            }
                            \\?-* {
                                puts -nonewline $fd "?<b>[string range [lindex $data $idx] 1 end]</b> "
                                lappend syntax_words_b [string range [lindex $data $idx] 1 end]
                            }
                            \\?*\\? {
                                set chars [expr [string length [lindex $data $idx]]-[string length [string trimright [lindex $data $idx] ?]]]
                                puts -nonewline $fd "?<i>[string range [lindex $data $idx] 1 end-$chars]</i>[string repeat ? $chars]"
                                lappend syntax_words_i [string range [lindex $data $idx] 1 end-$chars]
                            }
                            \\?* {
                                puts -nonewline $fd "?<i>[string range [lindex $data $idx] 1 end]</i>"
                                lappend syntax_words_i [string range [lindex $data $idx] 1 end]
                            }
                            *\\? {
                                puts -nonewline $fd "<i>[string range [lindex $data $idx] 0 end-1]</i>?"
                                lappend syntax_words_i [string range [lindex $data $idx] 0 end-1]
                            }
                            -* {
                                puts -nonewline $fd "<b>[lindex $data $idx]</b>"
                                lappend syntax_words_b [lindex $data $idx]
                            }
                            default {
                                puts -nonewline $fd "<i>[lindex $data $idx]</i>"
                                lappend syntax_words_i [lindex $data $idx]
                            }
                        }
                        incr idx
                    }
                }
                puts $fd ""
            }
            GLOBALSYNTAX: {
                if {$DESCR} {
                    set syntax_words_b ""
                    set syntax_words_i ""
                    set DESCR 0
                }
                puts $fd "<dt><h3>Oglna skadnia:</h3><br>"
                puts -nonewline $fd "<dt><b>[lindex $data 1]</b>"
                lappend syntax_words_b [lindex $data 1]
                if {[llength $data] > 2} {
                    set idx 2
                    while {[lindex $data $idx] != ""} {
                        puts -nonewline $fd " "
                        switch -glob -- [lindex $data $idx] {
                            \\?-*\\? {
                                puts -nonewline $fd "?<b>[string range [lindex $data $idx] 1 end-1]</b>?"
                                lappend syntax_words_b [string range [lindex $data $idx] 1 end-1]
                            }
                            \\?-* {
                                puts -nonewline $fd "?<b>[string range [lindex $data $idx] 1 end]</b> "
                                lappend syntax_words_b [string range [lindex $data $idx] 1 end]
                            }
                            \\?*\\? {
                                set chars [expr [string length [lindex $data $idx]]-[string length [string trimright [lindex $data $idx] ?]]]
                                puts -nonewline $fd "?<i>[string range [lindex $data $idx] 1 end-$chars]</i>[string repeat ? $chars]"
                                lappend syntax_words_i [string range [lindex $data $idx] 1 end-$chars]
                            }
                            \\?* {
                                puts -nonewline $fd "?<i>[string range [lindex $data $idx] 1 end]</i>"
                                lappend syntax_words_i [string range [lindex $data $idx] 1 end]
                            }
                            *\\? {
                                puts -nonewline $fd "<i>[string range [lindex $data $idx] 0 end-1]</i>?"
                                lappend syntax_words_i [string range [lindex $data $idx] 0 end-1]
                            }
                            -* {
                                puts -nonewline $fd "<b>[lindex $data $idx]</b>"
                                lappend syntax_words_b [lindex $data $idx]
                            }
                            default {
                                puts -nonewline $fd "<i>[lindex $data $idx]</i>"
                                lappend syntax_words_i [lindex $data $idx]
                            }
                        }
                        incr idx
                    }
                }
                puts $fd ""
            }
            SUBSYNTAX: {
                if {$DESCR} {
                    set syntax_words_b ""
                    set syntax_words_i ""
                    set DESCR 0
                }
                puts $fd "<br><p><dt><hr>"
                puts -nonewline $fd "<b>[lrange $data 1 2]</b>"
                lappend syntax_words_b [lindex $data 1]
                if {[llength $data] > 3} {
                    set idx 3
                    while {[lindex $data $idx] != ""} {
                        puts -nonewline $fd " "
                        switch -glob -- [lindex $data $idx] {
                            \\?-*\\? {
                                puts -nonewline $fd "?<b>[string range [lindex $data $idx] 1 end-1]</b>?"
                                lappend syntax_words_b [string range [lindex $data $idx] 1 end-1]
                            }
                            \\?-* {
                                puts -nonewline $fd "?<b>[string range [lindex $data $idx] 1 end]</b> "
                                lappend syntax_words_b [string range [lindex $data $idx] 1 end]
                            }
                            \\?*\\? {
                                set chars [expr [string length [lindex $data $idx]]-[string length [string trimright [lindex $data $idx] ?]]]
                                puts -nonewline $fd "?<i>[string range [lindex $data $idx] 1 end-$chars]</i>[string repeat ? $chars]"
                                lappend syntax_words_i [string range [lindex $data $idx] 1 end-$chars]
                            }
                            \\?* {
                                puts -nonewline $fd "?<i>[string range [lindex $data $idx] 1 end]</i>"
                                lappend syntax_words_i [string range [lindex $data $idx] 1 end]
                            }
                            *\\? {
                                puts -nonewline $fd "<i>[string range [lindex $data $idx] 0 end-1]</i>?"
                                lappend syntax_words_i [string range [lindex $data $idx] 0 end-1]
                            }
                            -* {
                                puts -nonewline $fd "<b>[lindex $data $idx]</b>"
                                lappend syntax_words_b [lindex $data $idx]
                            }
                            default {
                                puts -nonewline $fd "<i>[lindex $data $idx]</i>"
                                lappend syntax_words_i [lindex $data $idx]
                            }
                        }
                        incr idx
                    }
                }
                puts $fd ""
            }
            DESCRIPTION: {
                puts $fd "<dd><br><p>"
                set DESCR 1
            }
            EXAMPLE: {
                puts $fd "<br>"
                puts $fd "<dt><h3>Przykad</h3>"
                puts $fd "<dd><font face=courier><pre>"
            }
            ENDOFEXAMPLE {
                puts $fd "</pre>"
                puts $fd "</font>"
            }
            EVENTS {
                readEvents $fd
            }
            default {
                if {$data == "*/"} {
                    set sw 0
                    puts $fd </BODY>
                    puts $fd </HTML>
                } else {
                    set data [split $data]
                    foreach w "$syntax_words_i" {
                        if {[string match -nocase "* $w *" $data] || [string match -nocase "* ?$w? *" $data] \
                            || [string match -nocase "$w *" $data] || [string match -nocase "* $w?" $data] \
                            || [string match -nocase "*?$w *" $data] || [string match -nocase "* $w? *" $data]} {
                                set data [eval string map "{$w <i>$w</i>}" {$data}]
                        }
                    }
                    foreach w "$syntax_words_b" {
                        if {[string match -nocase "* $w *" $data] || [string match -nocase "* ?$w? *" $data] \
                            || [string match -nocase "$w *" $data] || [string match -nocase "* $w?" $data] \
                            || [string match -nocase "*?$w *" $data] || [string match -nocase "* $w? *" $data]} {
                                set data [eval string map "{$w <b>$w</b>}" {$data}]
                        }
                    }
                    set data [join $data]
                    puts $fd "$data"
                }
            }
        }
    } else {
        if {[string match "/\* Tcl Command *" $data]} {
            set sw 1
            set fd [open [lindex $data 3].html w]
            puts $fd {<HTML><HEAD><TITLE>Manpage of TCL module for Kadu</TITLE>
<META http-equiv="Content-Type" content="text/html; charset=iso-8859-2">
</HEAD><BODY>
<H1>Modu TCL dla klienta Kadu</H1>
<hr>
<a href=index.html><b>Spis komend</b></a>
<hr>}
        }
    }
}
close $fd
close $fd2


set version ""
set fd [open ../../tcl.cpp r]
while {![eof $fd] && $version == ""} {
    gets $fd data
    if {[lindex $data 1] == "MODULE_TCL_VERSION"} {
        set version [lindex $data 2]
    }
}
close $fd
set fd [open index.html w]
puts $fd {<HTML><HEAD><TITLE>Modu TCL dla Kadu</TITLE>
<META http-equiv="Content-Type" content="text/html; charset=iso-8859-2">
</HEAD><BODY>
<H1>Modu TCL dla klienta Kadu</H1>
<hr>}
puts $fd "<b>Dokumentacja aktualna dla moduu w wersji $version.</b>"
puts $fd {<hr>
<H2>SPIS KOMEND</H2>

<TABLE CELLSPACING=3>}

set list [glob -nocomplain *.html]
set idx [lsearch $list index.html]
set list [lsort [lreplace $list $idx $idx]]
set cols 4
        
set cnt [llength $list]
while {[expr {[expr $cnt/$cols]*$cols}] != $cnt} {
    incr cnt
}
        
for {set i 0} {$i < [expr $cnt/$cols]} {incr i} {
    puts $fd <TR>
    set w1 [lindex $list $i]
    for {set j 1} {$j <= $cols} {incr j} {
        set w[expr $j+1] [lindex $list [expr $i+[expr [expr $cnt/$cols]*$j] ]]
    }
    for {set j 1} {$j <= $cols} {incr j} {
        set tmp w$j
        puts $fd "<TD WIDTH=100><A HREF=\"[set $tmp]\">[lindex [split [set $tmp] .] 0]</A></TD>"
    }
    puts $fd </TR>
}
        
puts $fd {</TABLE>

<HR>

<H2>Dodatkowe informacje</H2>}
puts $fd {
<h4>Ikony</h4>
W niektrych komendach mona uy ikony. Tak ikon powinna stanowi wybrana nazwa pliku png, wraz ze ciek do niego,
lub te nazwa ikony z pliku icons.conf (w katalogu katalogu_instalacji_kadu/icons/).
Nazw pliku mona poda bez rozszerzenia, tj. back, zamiast back.png. <u>Nie jest</u> to wymg.}

puts $fd {
<h4>Statusy</h4>
Status w skryptach TCL moe przyj nastpujce wartoci:<br><br>
<table>
<tr><td><b>notavailable</b></td><td>(niedostpny)</td></tr>
<tr><td><b>notavailable+description</b></td><td>(niedostpny z opisem)</td></tr>
<tr><td><b>available</b></td><td>(dostpny)</td></tr>
<tr><td><b>available+description</b></td><td>(dostpny z opisem)</td></tr>
<tr><td><b>busy</b></td><td>(zajty)</td></tr>
<tr><td><b>busy+description</b></td><td>(zajty z opisem)</td></tr>
<tr><td><b>invisible</b></td><td>(niewidoczny)</td></tr>
<tr><td><b>invisible+description</b></td><td>(niewidoczny z opisem)</td></tr>
<tr><td><b>blocked</b></td><td>(jeste zablokowany przez tego uytkownika)</td></tr>
</table><br>
Naley nadmieni, e tryb <b>invisible</b>, oraz odpowiednik z opisem, nie zawsze s widoczne - w zalenoci od tego
czy Kadu wykryo ten status, w innym wypadku zwracany status to <b>notavailable</b> (z ewentualnym opisem).<br>}

puts $fd {
<h4>Skrty klawiszowe</h4>
Argumenty skrtw klawiszowych mog przyjmowa posta:<br>
<font face=courier>&lt;modyfikator&gt;+&lt;klawisz&gt;</font><br>
Modyfikatorem moe by "Ctrl", "Alt", "Shift", lub "Meta", klawiszem moe by dowolna litera, jak i cae nazwy,
jak np "F5", "Return", "Home", itd.}

puts $fd {
<h4>Zmienne globalne</h4>
W kadym skrypcie inicjowane s dodatkowe zmienne globalne, ktre mog okaza si przydatne.<br>
<font face="courier">$kadu(version)</font> zwraca numer wersji Kadu, tj. 0.3.7, 0.4.0, etc.<br>
<font face="courier">$kadu(datadir)</font> zwraca katalog plikw Kadu (tzw. prefix danych). W domylnej
instalacji jest to <b>/usr/local/share/kadu</b>.<br>
<font face="courier">$kadu(configdir)</font> zwraca ciek do katalogu, w ktrym aktualna sesja Kadu trzyma
swoje pliki konfiguracyjne.<br>
<font face="courier">$module(version)</font> zwraca numer wersji moduu, tj. 0.4.3, lub 1.0.0, etc.<br>
<font face="courier">$module(scriptname)</font> zwraca ciek do katalogu, w ktrym znajduje si
aktualnie wykonywany skrypt.<br>
<font face="courier">$module(codename)</font> zwraca nazw kodow wersji, tj "Antila".<br>
<font face="courier">$module(release)</font> zwraca dat wydania tej wersji moduu w postaci YYYYMMDD.<br>
<font face="courier">$module(scriptpath)</font> zwraca pen ciek do katalogu, w ktrym znajduje si
aktualnie wykonywany skrypt.<br>
<font face="courier">$gg(uin)</font> zwraca numer UIN aktualnego uytkownika Kadu.<br>
<font face="courier">$gg(nick)</font> zwraca nazw lokalnego uytkownika Kadu (w odmylnej
konfiguracji Kadu jest to "Ja").<br>}


puts $fd {
<P><P>
</BODY>
</HTML>}
close $fd

cd $CDIR
