# Debugger v1.0

proc traceCmd {cmd op} {
    puts "\[TCL DEBUG\]: $cmd"
}

proc addDebug {cmd} {
    if {"[info commands $cmd]" != ""} {
        trace add execution $cmd enter traceCmd
    } else {
        puts "ERROR: Command $cmd doesn't exist!"
    }
}

proc addProc {cmd args} {
    addDebug [lindex $cmd 1]
}

trace add execution proc leave addProc

foreach cmd {chat configfile hint ignore event on msg play quit after user status connect disconnect
            console config usermenu inputdialog filedialog msgbox listbox menu
} {
    if {"[info commands $cmd]" != ""} {
        trace add execution $cmd enter traceCmd
    }
}

foreach cmd "encoding if pid switch eof incr after error info append eval interp
            proc array exec join exit lappend pwd expr lindex fblocked linsert read fconfigure list regexp
            fcopy llength tell file load regsub time fileevent lrange rename
            lreplace unknown binary flush lsearch return unset break for lset scan update catch foreach
            lsort seek uplevel cd format set upvar clock gets socket variable close glob namespace source
            concat global open split while continue package string subst vwait after
" {
    trace add execution $cmd enter traceCmd
}
