#!/bin/bash
#\
exec tclsh $0 ${@}

fconfigure stdout -buffering none

cd ../translations
foreach file "empty [glob -nocomplain *.po]" {
    if {![file writable $file]} {
	puts "File $file isn't writable. All translations files must be writable to update translations."
	exit 1
    }
}

puts -nonewline "Generating"

if {[file exists empty]} {
    file rename -force empty empty.bak
}

set fd [open empty w]
set fd2 [open empty.bak r]
set i 0
while {![eof $fd2] && $i < 12} {
    puts $fd [gets $fd2]
    incr i
}
close $fd2

# Czytanie plikow zrodlowych.
set po(id) ""
puts -nonewline .
cd ../..

proc search {list str} {
    set i 0
    foreach tmp $list {
	if {$tmp == $str} {
	    return $i
	}
    }
    return -1
}

foreach f "[glob -directory kadupro/scripts -nocomplain *.kkp] kadupro.tcl" {
    set fd2 [open $f r]
    set line 1
    while {![eof $fd2]} {
        gets $fd2 data
        if {[string match {*\[tr \{*\}*\]*} $data]} {
            foreach tmp [regexp -all -inline -- {\[tr\ \{[^\}]*\}[^\]]*\]} $data] {
		set idx [expr {[string first \} $tmp]-1}]
                set str [string range $tmp 5 $idx]
                if {[search $po(id) $str] == -1} {
                    lappend po(id) $str
                }
		if {[string first \" $str] > -1} {
		    puts ""
		    puts "Source messages can't contain \" chars! ($f:$line)"
		    set err 1
		}
                lappend po(lines:$str) "$f:$line"
            }
        }
        incr line
    }
    close $fd2
    puts -nonewline .
}

if {[info exists err]} {
    exit 1
}

# Tworzenie czystego pliku.
foreach id "$po(id)" {
    foreach l "$po(lines:$id)" {
        puts $fd "#: $l"
    }
    puts $fd "msgid \"$id\""
    puts $fd "msgstr \"\""
    puts $fd ""
}
close $fd
puts "Done"

# Czytanie tlumaczen i przeniesienie starych do nowych, a takze usuniecie nieaktualnych.
puts "Updating translations:"
cd kadupro/translations
foreach f [glob -nocomplain *.po] {
    puts -nonewline "File: $f..........."
    set fd [open $f r]
    while {![eof $fd]} {
        gets $fd data
        set str [string range $data 7 end-1]
        if {[lindex [split $data] 0] == "msgid"} {
            if {[lsearch -exact $po(id) $str] > -1} {
                set po(trans:$str) "[string range [gets $fd] 8 end-1]"
            }
        }
    }
    close $fd
    file rename -force $f $f.bak
    set fd [open $f w]

    # Przekopiowanie pierwszych linii
    set fd2 [open $f.bak r]
    set i 0
    while {![eof $fd] && $i < 13} {
        puts $fd [gets $fd2]
        incr i
    }
    close $fd2
    puts $fd ""

    # Kreowanie pliku tlumaczen
    foreach id "$po(id)" {
        foreach l "$po(lines:$id)" {
            puts $fd "#: $l"
        }
        puts $fd "msgid \"$id\""
        if {[info exists po(trans:$id)]} {
            puts $fd "msgstr \"$po(trans:$id)\""
        } else {
            puts $fd "msgstr \"\""
        }
        puts $fd ""
    }
    close $fd
    puts "Done"
}
puts "OK! I'm done!"
