#ifndef TCLMISC_H
#define TCLMISC_H

#include <qmap.h>
#include <qtextedit.h>
#include <tcl.h>
#include "gadu.h"

class QKeyEvent;
class QString;

class TclMisc
{
	private:
		typedef QMap<QString,int> TclEventDef;
		TclEventDef tclEventDef;

	public:
		TclMisc();

		/*
			Konwersje statusw z GaduStatus i KaduStatus
			do acucha TCL i na odwrt.
		*/
		QString GGStatusToTclStatus(int);
		int TclStatusToGGStatus(QString);
		bool isDescStatus(int status);
		void setTclStatus(QString stat, QString desc = "");
		QString KaduStatusToTclStatus(int);
		int TclStatusToKaduStatus(QString);
		
		/*
			Konwersja enumw QT::Key na acuch TCL.
		*/
		void getKey(QKeyEvent*, QString&, QString&);

		/*
			Konwersja bdw GG na acuch TCL.
		*/
		QString GaduErrorToString(GaduError);

		/*
			Konwersja symbolicznych zdarze do acucha TCL
			i na odwrt.
		*/
		int getEventId(QString);
		QString getEventString(int id);
		QStringList getEvents();

		/*
			Uproszczony sposb ustawiania rezultatw w interpreterze TCL,
			oraz dostosowanie ich do QString.
		*/
		void setTclResult(Tcl_Interp*, QString);
		void appendTclResult(Tcl_Interp*, QString);

		/*
			Zamiana indeksw pozycji TCL na indeksy QT
		*/
		QTextEdit::CursorAction tclIndexToQtIndex(QString);

		/*
			Zmiana listy TCL na list acuchw QT.
		*/
		QStringList tclListToQtList(const char* str);
		QStringList tclListToQtList(QString str);
};

#endif
