/***************************************************************************
 *																		 *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or	 *
 *   (at your option) any later version.								   *
 *																		 *
 ***************************************************************************/

#include "tclstring.h"

#include <qstring.h>

TclString::TclString()
{
	Tcl_DStringInit(&ds);
}

TclString::TclString(QString str)
{
	Tcl_DStringInit(&ds);
	QCString utf = str.utf8();
	Tcl_Obj* result = Tcl_NewStringObj((const char* const)utf, utf.length());
	Tcl_DStringAppend(&ds, Tcl_GetString(result), utf.length());
}

TclString::~TclString()
{
	Tcl_DStringFree(&ds);
}

void TclString::append(QString str)
{
	QCString utf = str.utf8();
	Tcl_Obj* result = Tcl_NewStringObj((const char* const)utf, utf.length());
	Tcl_DStringAppend(&ds, Tcl_GetString(result), utf.length());
}

void TclString::appendElement(QString str)
{
	QCString utf = str.utf8();
	Tcl_Obj* result = Tcl_NewStringObj((const char* const)utf, utf.length());
	Tcl_DStringAppendElement(&ds, Tcl_GetString(result));
}

void TclString::listBegin()
{
	Tcl_DStringStartSublist(&ds);
}

void TclString::listEnd()
{
	Tcl_DStringEndSublist(&ds);
}

int TclString::length()
{
	return Tcl_DStringLength(&ds);
}

QString TclString::value()
{
	return QString::fromUtf8(Tcl_DStringValue(&ds));
}

void TclString::setResult(Tcl_Interp* interp)
{
	Tcl_DStringResult(interp, &ds);
}

char* TclString::dString()
{
	return Tcl_DStringValue(&ds);
}
