/***************************************************************************
 *																		 *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or	 *
 *   (at your option) any later version.								   *
 *																		 *
 ***************************************************************************/

#include "tcltimer.h"
#include "tcl_scripting.h"

TclTimer::TclTimer(TclSession* s)
{
	kdebugf();
	connect(this, SIGNAL(timeout()), this, SLOT(exec()));
	tsess = s;
}

void TclTimer::setCode(QString str)
{
	kdebugf();
	code = str;
}

void TclTimer::remove()
{
	kdebugf();
	QValueList<timerID>::Iterator it;
	for ( it = tsess->tclTimers.begin(); it != tsess->tclTimers.end(); it++ )
	{
		if ((*it).id == cid)
		{
			tsess->tclTimers.remove(it);
			delete (*it).ptr;
			break;
		}
	}
}

void TclTimer::exec()
{
	/*
		kdebugf() is ommited, becouse of craps
		it was generating in loop case.
	*/
	QCString utf = code.utf8();
	Tcl_Obj* result = Tcl_NewStringObj((const char* const)utf, utf.length());
	int ret = Tcl_Eval(tsess->tclInt(), Tcl_GetString(result));
	if (ss)
		remove();

	if (ret == TCL_ERROR)
	{
		tsess->error(Tcl_GetStringResult(tsess->tclInt()));
		stop();
	}
}

void TclTimer::kill()
{
	kdebugf();
	stop();
	remove();
}

void TclTimer::currIdent(int id)
{
	kdebugf();
	cid = id;
}

void TclTimer::setSingleShot(bool shot)
{
	kdebugf();
	ss = shot;
}

bool TclTimer::isSingleShot()
{
	kdebugf();
	return ss;
}
